package de.bsvrz.vew.bmvew.bmvew.regel;

import java.util.ArrayList;
import java.util.List;

import de.bsvrz.dav.daf.main.ResultData;

/**
 * Singleton-Klasse. Sie kapselt die Liste der Regeln. 
 *
 * @version $Revision: 1.2 $ / $Date: 2010/09/14 10:08:10 $ / ($Author: Pittner $)
 *
 * @author Dambach-Werke GmbH
 * @author Timo Pittner
 *
 */
public class RegelBasis
{
  /**
   * Die Singleton-Instanz
   */
  private static RegelBasis _instance;
  
  /**
   * Die Liste der Regeln
   */
  private static List<Regel> _regelBasis = new ArrayList<Regel>();

  /**
   * Konstruktor, ist fr andere Klassen nicht sichtbar
   */
  private RegelBasis()
  {
    // TODO Auto-generated constructor stub
  }
  
  /**
   * Holt die einzige Singleton-Instanz der Klasse
   * 
   * @return
   */
  public static RegelBasis getSingletonInstance(){
    
    return _instance;
  }
  
  public static List<Regel> getRegelBasisListe(){
    
    return _regelBasis;  
  }
  
  /**
   * Arbeitet die Liste der Regeln ab
   * 
   * @param betriebsMeldung
   */
  public static void interpretiere(ResultData betriebsMeldung){

    for (Regel regel : _regelBasis)
    {
      if (!regel.bearbeite(betriebsMeldung))
          break;      
    }      
  }
  
  /**
   * Loescht die Liste der Regeln
   */
  public static void loescheRegelBasisListe(){
    
    _regelBasis = new ArrayList<Regel>();
  }
  
  
  
  
  
  
  
  
  

}
